import { createStore } from "vuex";

const roomsStore = createStore({
  state() {
    return {
      rooms: [
        {
          users: "clemnce",
          object:
            "Lorem magna minim cillum labore ex eiusmod proident excepteur sint irure ipsum.",
          mailbox: 1,
        },
        {
          users: "juliette",
          object:
            "Lorem magna minim cillum labore ex eiusmod proident excepteur sint irure ipsum.",
          mailbox: 1,
        },
        {
          users: "jean",
          object:
            "Lorem magna minim cillum labore ex eiusmod proident excepteur sint irure ipsum.",
          mailbox: 2,
        },
        {
          users: "luc",
          object:
            "Lorem magna minim cillum labore ex eiusmod proident excepteur sint irure ipsum.",
          mailbox: 2,
        },
      ],
      mailboxes: [
        { mail: "mail@domain.com", id: 1 },
        { mail: "name@example.com", id: 2 },
      ],
      activeMailbox: -1
    };
  },
  mutations: {
    setActiveMailbox(state, payload) {
        state.activeMailbox = payload;
    }
  },
  getters: {
    folderRooms: (state) => () => {
        if (state.activeMailbox == -1) return state.rooms;
        return state.rooms.filter(room => room.mailbox == state.activeMailbox);
    }
  }
});

export default roomsStore;
